from twisted.internet import gtk2reactor
gtk2reactor.install()
from twisted.spread import pb
from twisted.internet import reactor,defer
from twisted.cred import credentials

import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade
import Image
#http://domnit.org/stepic/doc/
import stepic
import StringIO
#http://www.dlitz.net/software/pycrypto/
from Crypto.Cipher import ARC2
from Crypto.Util import RFC1751

#http://danmarner.blogspot.com/2008/05/creating-message-box-with-pygtk-and.html
class messageBox:
    def __init__(self, lbl_msg = 'Message here',dlg_title = ''):
         self.wTree = gtk.glade.XML('msgbox.glade')
         self.dlg = self.wTree.get_widget('dialog1')
         self.lbl = self.wTree.get_widget('label1')
         self.dlg.set_title(dlg_title)
         self.lbl.set_text(lbl_msg)
         handlers = { 'on_okbutton1_clicked':self.done }
         self.wTree.signal_autoconnect( handlers )
    
    def done(self,w):
         self.dlg.destroy()

class inline_image():
    def __init__(self,filename=None,string=None):
        if string == None:
            self.filename = filename
            self.pb = gtk.gdk.pixbuf_new_from_file(self.filename)
        else:
            self.get_pixbuf(string)
    def get_string(self):
        pix = self.pb.get_pixels()
        inline_img = [pix,self.pb.get_has_alpha(), #self.pb.get_bits_per_sample() always 8
                self.pb.get_width(),self.pb.get_height(),self.pb.get_rowstride()]        
        return inline_img
    
    #for some reason sometimes the int objects have weird extra data, this is to strip that out
    def cint(self,d):
        if type(d) == int:
            return d
        else:
            d = str(d)
        ni = ""
        for s in string:
            try:
                n = int(s)
                ni = ni + s
            except:
                pass
        return int(ni)
        
    def get_pixbuf(self,img):
        color = gtk.gdk.COLORSPACE_RGB
        self.pb = gtk.gdk.pixbuf_new_from_data(img[0],color,img[1],8,self.cint(img[2]),
            self.cint(img[3]),self.cint(img[4]))
        return self.pb
        
class client_gui():
    glade_file = "covert_chat.glade" 
    avatar = None
    def __init__(self):
        
        self.xml = gtk.glade.XML(self.glade_file)
        
        ##handle the tree
        self.user_tree = self.xml.get_widget('treeview2')
        #Create the listStore Model to use with the wineView
        self.TreeList = gtk.ListStore(gtk.gdk.Pixbuf, str)
        #Attatch the model to the treeView
        self.user_tree.set_model(self.TreeList)
        
        col = gtk.TreeViewColumn("Avatar", gtk.CellRendererPixbuf(),pixbuf=0)
        col.set_resizable(False)
        #col.set_sort_column_id(columnId)
        self.user_tree.append_column(col)
        
        col = gtk.TreeViewColumn("User", gtk.CellRendererText(), text=1)
        col.set_resizable(False)
        self.user_tree.append_column(col)
        
        
        self.message_window = self.xml.get_widget('textview1')
        self.new_text = self.xml.get_widget('textview2')
        self.gmi = self.xml.get_widget('radiomenuitem1')
        self.status_bar = self.xml.get_widget('statusbar')
        self.context_id = self.status_bar.get_context_id("Covert Client")
        
        win = self.xml.get_widget('window1')
        win.connect('destroy', gtk.main_quit)
        event_dic = {"on_MainWindow_destroy" : self.shutdown_client,
                    "program_quit": self.shutdown_client,
                    "on_button1_clicked" : self.send_btn,
                    "on_imagemenuitem1_activate": self.connect_gui,
                    "add_emo1": self.add_emoticon1,
                    "add_emo2": self.add_emoticon2,
                    "add_emo3": self.add_emoticon3,
                    "add_emo4": self.add_emoticon4,
                    "add_emo5": self.add_emoticon5,
                    "add_emo6": self.add_emoticon6,
                    "group_add": self.add_group,
                    "change_group": self.change_group,
                    "check_user":self.check_user_men,
                    "status_pushed":self.status_message,
                    "on_about_activate":self.call_about}
        self.xml.signal_autoconnect(event_dic)
        win.show()
        self.server = None
        self.covert = []
        self.avatar_string = None
        self.img_iters = []
        self.active_group = "None"
        self.covert_client = None
        
        tag_table = self.message_window.get_buffer().get_tag_table()
        user_tagb = gtk.TextTag("blue")
        user_tagr = gtk.TextTag("red")
        user_tagb.set_property("foreground", "blue")
        user_tagr.set_property("foreground", "red")
        tag_table.add(user_tagb)
        tag_table.add(user_tagr)
        alert_new = False
        
    def call_about(self,widget):
        messageBox("Covert Client \n Written by Tim Wylie \n 2009","About")
        
    def shutdown_client(self,widget):
        if self.covert_client != None:
            self.covert_client.logout()
        else:
            self._shutdown_client()
        
    def _shutdown_client(self):
        reactor.stop()
        gtk.main_quit
        
    def client_connect(self,host,port,creds):
        self.covert_client = PbAuthTester(creds)
        self.covert_client.start(host,port)
        
    #cheap lazy way to do this
    show_connect = True
    def load_content(self):
        #set text window
        if self.show_connect==True:
            self.message_window.get_buffer().insert(
                self.message_window.get_buffer().get_end_iter(), "Connected as " + self.username)
            self.show_connect=False
        self.call_userlist()

    def call_userlist(self):
        #load tree
        defer.maybeDeferred(self.covert_client.get_users).addCallback(self.load_users)
    
    def load_users(self,users):
        #should probably fix problem with selection
        self.TreeList.clear()
        for i in range(len(users[1])):
            img = None
            if users[0][i] != None:
                img = inline_image(string=users[0][i]).pb
            self.TreeList.append((img,users[1][i]))
        
        #clear out covert users who have logged off
        #this code has a bug somewhere
        '''
        for c in range(len(self.covert)-1,-1,-1):
            u_in = False
            for u in range(len(users[1])):
                if self.covert[c][0]==users[1][i]:
                    u_in = True
            
            if u_in == False:
                self.covert.pop(c)
        '''
        #check for new users
        reactor.callLater(20,self.call_userlist)
    
    #helper conversion functions
    def pixbuf2Image(self,pb):
        width,height = pb.get_width(),pb.get_height()
        img = Image.fromstring("RGB",(width,height),pb.get_pixels())
        return img

    def Image2pixbuf(self,im):  
        file1 = StringIO.StringIO()  
        im.save(file1, "ppm")  
        contents = file1.getvalue()  
        file1.close()  
        loader = gtk.gdk.PixbufLoader("pnm")  
        loader.write(contents, len(contents))  
        pixbuf = loader.get_pixbuf()  
        loader.close()  
        return pixbuf
        
    def change_status(self,txt):
        self.status_bar.push(self.context_id,txt)
    
    #this is called by a handler whenever text is pushed from change_status    
    def status_message(self, *widget):
        reactor.callLater(3,self.remove_status)
        
    def remove_status(self,*data):
        self.status_bar.pop(self.context_id)
    
    def check_user_men(self,widget):
        if self.active_group != "None" and self.active_group != None:
            sel_node = self.user_tree.get_selection().get_selected()
            if sel_node[1] != None:
                to_user = self.TreeList.get_value(sel_node[1],1)
                #self.covert.append((to_user,self.active_group,False))
                self.alert_new = True
                self.covert_client.add_group_check(to_user,self.active_group)
            else:
                self.change_status("No user selected")
        else:
            self.change_status("Group set to None")
        
    #handler for the "add group" menu option, shows dialog                        
    def add_group(self,widget):
        xml2 = gtk.glade.XML(self.glade_file)
        win = xml2.get_widget('dialog3')
        gn = xml2.get_widget('group_entry')
        men = self.xml.get_widget('menu4')
        x = win.run()
        if x == 1:
            new_group = gn.get_text()
            gmi = gtk.RadioMenuItem(group=self.gmi,label=new_group)
            gmi.connect('activate', self.change_group)
            men.insert(gmi,0)
            men.show_all()
        win.destroy()
        
    #called whenever the group radio button is changed in the menu
    def change_group(self,widget):
        if widget.get_active() == True:
            gname = widget.get_children()[0].get_text()
            self.active_group = gname
            
            
    def pad(self,text,bs):
        while len(text)%bs > 0:
            text = text + " "
        return text
        
    def enc_msg(self,text):
        obj=ARC2.new(self.active_group)
        #block size must be a multiple of 8 for des
        ciph = obj.encrypt(self.pad(text,8))
        #get hex string
        en_ctxt = RFC1751.key_to_english(ciph)
        return en_ctxt 
        
    def dec_msg(self,text):
        obj=ARC2.new(self.active_group)
        ptxt = obj.decrypt(RFC1751.english_to_key(text))
        return ptxt
            
    def show_messagebox(self,pic,user):
        try:
            s = stepic.decode(self.pixbuf2Image(pic))
            data = s.decode()
            txt = self.dec_msg(data)
            messageBox(txt,'Message from ' + user)
        except:
            pass
        
    #i do not check the length of the message, so if the message is too
    #long it simply excepts out and no message is sent with the picture
    def get_message(self,pic,to_user):
        try:
            xml2 = gtk.glade.XML(self.glade_file)
            win = xml2.get_widget('dialog2')
            gn = xml2.get_widget('textview3')
            win.set_title('Message to ' + to_user)
            x = win.run()
            if x == 1:
                msg = gn.get_buffer().get_slice(gn.get_buffer().get_start_iter(),
                    gn.get_buffer().get_end_iter())
                txt = self.enc_msg(msg)
                im = self.pixbuf2Image(pic)
                im2 = stepic.encode(im,txt)
                npic = self.Image2pixbuf(im2)
        except:
            npic = pic
        win.destroy()
        return npic
        
    #new messages are sent here            
    def incoming_message(self,user,msg,img=False,color="red"):
        self.message_window.get_buffer().insert_with_tags_by_name(
            self.message_window.get_buffer().get_end_iter(), "\n" + str(user)+":", color)

        if img == False:
            self.message_window.get_buffer().insert(
                self.message_window.get_buffer().get_end_iter(), msg)
        else:
            pix = inline_image(string=msg).pb
            self.message_window.get_buffer().insert_pixbuf(
                self.message_window.get_buffer().get_end_iter(), pix)
            if len(self.covert) > 0:
                for c in self.covert:
                    if c[0] == user and c[1] == self.active_group:
                        self.show_messagebox(pix,user)
            

    #the handler for the send button    
    def send_btn(self, widget):
        sel_node = self.user_tree.get_selection().get_selected()
        if sel_node[1] != None:
            to_user = self.TreeList.get_value(sel_node[1],1)  #iter,column
            if to_user != self.username:
                nmsg = self.new_text.get_buffer().get_slice(
                    self.new_text.get_buffer().get_start_iter(),self.new_text.get_buffer().get_end_iter())
                #post it on our screen
                self.incoming_message(self.username +"->"+to_user,nmsg,color="blue")
                #delete text
                self.new_text.get_buffer().delete(
                    self.new_text.get_buffer().get_start_iter(),self.new_text.get_buffer().get_end_iter())
                self.covert_client.send_message(to_user,nmsg)
        else:
            self.change_status("No user selected")
           
    #called with File/Connect - shows connect dialog and sets variables
    def connect_gui(self,widget):
        if self.server == None:
            #load config dialogue
            #get variables from form
            xml2 = gtk.glade.XML(self.glade_file)
            win = xml2.get_widget('dialog1')
            servw = xml2.get_widget('entry3')
            servw.set_text("localhost")
            portw = xml2.get_widget('entry4')
            portw.set_text("8789")
            userw = xml2.get_widget('entry1')
            passw = xml2.get_widget('entry2')
            fcbw = xml2.get_widget('filechooserbutton1')
            #run form, get results
            x = win.run()
            if (x == 1):
                self.server = servw.get_text()
                self.port = portw.get_text()
                self.username = userw.get_text()
                password = passw.get_text()
                if len(self.username) == 0:
                    self.change_status("No username")
                else:
                    try:
                        #pixbuf of image
                        self.avatar = fcbw.get_filename()
                        if self.avatar != None:
                            self.avatar_file = gtk.gdk.pixbuf_new_from_file(self.avatar)
                            self.avatar_string = inline_image(filename=self.avatar).get_string()
                     
                        creds = credentials.UsernamePassword(self.username, password)
                        self.client_connect(self.server,self.port,creds)
                    except:
                        self.covert_client = None
                        self.change_status("Problems Connecting")
                
            win.destroy()
        
    def covert_user(self, result):
        self.covert = result
        if self.alert_new == True and len(self.covert)>0:
            x = "Covert with "
            for r in result:
                x = x + r[0] + " "
            self.alert_new = False
            self.change_status(x)
        
    def add_emoticon1(self,widget):
        self.insert_emoticon(1)
    def add_emoticon2(self,widget):
        self.insert_emoticon(2)
    def add_emoticon3(self,widget):
        self.insert_emoticon(3)
    def add_emoticon4(self,widget):
        self.insert_emoticon(4)
    def add_emoticon5(self,widget):
        self.insert_emoticon(5)
    def add_emoticon6(self,widget):
        self.insert_emoticon(6)
        
    def insert_emoticon(self,picked):
        sel_node = self.user_tree.get_selection().get_selected()
        if sel_node[1] != None:
            to_user = self.TreeList.get_value(sel_node[1],1)  #iter,column
            if to_user != self.username:
                imge = inline_image(filename="emoticons/femoticon"+str(picked)+".png")
                if len(self.covert) > 0:
                    for c in self.covert:
                        if c[0] == to_user and c[1] == self.active_group:
                            imge.pb = self.get_message(imge.pb,to_user)
                self.incoming_message(self.username +"->"+to_user,imge.get_string(),img=True,color="blue")
                #send it
                self.covert_client.send_message(to_user,imge.get_string(),img=True)
            else:
                self.change_status("Self selected")    
        else:
            self.change_status("No user selected")
            
            
#####################################################################################
#####################################################################################
#####################################################################################
#####################################################################################
#####################################################################################



class PbAuthTester(object):
    def __init__(self, credentials):
        self.credentials = credentials
        self.server = None
        self.userid = None
        
    def start(self,host,port):
        self.connect(host,port).addErrback(self._catchFailure)
        
    def connect(self,host,port):
        factory = pb.PBClientFactory()
        reactor.connectTCP(host,int(port),factory) #"localhost", 8789, factory)
        return factory.login(self.credentials).addCallback(self._connected)
        
    def _connected(self, rootObj):
        self.server = rootObj
        self.register()
            
    def register(self):
        self.server.callRemote(
            "register",self.credentials.username,cg.avatar_string).addCallback(
            self._registered)
            
    def _registered(self, result):
        if result != False:
            self.userid = result
            cg.load_content()
            reactor.callLater(1,self.receive_message)
    
    def get_users(self):
        return self.server.callRemote("userlist").addCallback(self._getusers)
            
    def _getusers(self,result):
        return result
        
    def send_message(self,to,msg,img=False):
        #print self.credentials.username,":",msg
        return self.server.callRemote("incoming",self.userid,to,msg,img)
        
    def receive_message(self):
        return self.server.callRemote(
            "receive",self.userid).addCallback(self._received)
            
    def _received(self, result):
        if result != False:
            for r in result:
                cg.incoming_message(r[0],r[1],r[2])
        #update userlist        
        reactor.callLater(1,self.receive_message)
        
    def add_group_check(self,to_user,group):
        self.server.callRemote("add_check",self.credentials.username,to_user,group)
        self.check_group()
            
    def check_group(self):
        self.server.callRemote("check_group",self.credentials.username).addCallback(self._checked_group)
        
    def _checked_group(self, result):
        if result != False:
            cg.covert_user(result)
        reactor.callLater(20,self.check_group)
        
    def logout(self):
        self.server.callRemote("logout",self.credentials.username).addCallback(self._logout)
        
    def _logout(self,result):
        cg._shutdown_client()
        
    def _catchFailure(self, failure):
        cg.change_status("Not a valid login")
        cg.covert_client=None
        cg.username = None
        cg.server = None
        
if __name__ == "__main__":
    cg = client_gui()
    reactor.run()