from twisted.spread import pb
from twisted.cred import checkers, portal
from zope.interface import implements
import random

'''
How checks work
user1 | user2 | group in question | checked1 | checked2 

Whenever a user checks it is added to a table as listed above 
with the checked being marked as true.  then when the other user
checks theirs gets marked as true.  when both are true the result is
returned

I have considered deleting this record from the table once both have
checked, but for simplicity I'm not adding it.
'''

class UserList:
    def __init__(self):
        self.users = []
        self.ids = []
        self.avatars = []
        self.messages = []
        self.checks = []
        
    def get_userlist(self):
        return (self.avatars,self.users)
        
    def get_messages(self,userid):
        try:
            i = self.ids.index(userid)
            msg = self.messages[i]
            self.messages[i] = []
            return msg
        except:
            pass
        
    def addMessage(self,username,msg):
        try:
            i = self.users.index(username)
            fi = self.ids.index(msg[0])
            self.messages[i].append((self.users[fi],msg[1],msg[2]))
            return True
        except:
            pass
        
    def add_user(self,regint,username,avatar):
        try:
            i = self.users.index(username)
            if i >= 0:
                self.ids[i] = regint
                self.avatars[i] = avatar
        except:
            self.ids.append(regint)
            self.avatars.append(avatar)
            self.users.append(username)
            self.messages.append([])

    def logout(self,user):
        try:
            i = self.users.index(user)
            self.users.pop(i)
            self.ids.pop(i)
            self.avatars.pop(i)
            self.messages.pop(i)
            for c in range(len(self.checks)-1,-1,-1):
                if self.checks[c][0] == user or \
                    self.checks[c][1] == user:
                    self.checks.pop[c]
        except:
            pass
        
    def add_check(self,user_from,user_to,group):
        new_record = True
        for i in range(len(self.checks)):
            if self.checks[i][0] == user_from and \
                self.checks[i][1] == user_to and \
                self.checks[i][2] == group:
                self.checks[i][3] = True
                new_record = False
                return
            if self.checks[i][1] == user_from and \
                self.checks[i][0] == user_to and \
                self.checks[i][2] == group:
                self.checks[i][4] = True
                new_record = False
                return
        if new_record == True:        
            self.checks.append([user_from,user_to,group,True,False])
    
    def check_group(self,user):
        result = []
        for i in range(len(self.checks)):
            if self.checks[i][0] == user:
                if self.checks[i][4] == True:
                    result.append([self.checks[i][1],self.checks[i][2]])
            if self.checks[i][1] == user:              
                if self.checks[i][3] == True:
                    result.append([self.checks[i][0],self.checks[i][2]])                
        return result
        
        
        
        
class UserPerspective(pb.Avatar):
    def __init__(self, uList):
        self.user_list = uList
        
    def perspective_incoming(self,userid_from,user_to,msg,img):
        self.user_list.addMessage(user_to,(userid_from,msg,img))
        return True
        
    def perspective_receive(self,userid):
        try:
            m = self.user_list.get_messages(userid)
            if len(m)>0:
                return m
            else:
                return False
        except:
            return False
        
    def perspective_register(self,username,avatar):
        regint = random.randint(1,999999999)
        self.user_list.add_user(regint,username,avatar)        
        return regint
        
    def perspective_userlist(self):
        return self.user_list.get_userlist()

    def perspective_add_check(self,user_from,user_to,group):
        return self.user_list.add_check(user_from,user_to,group)
        
    def perspective_check_group(self,user):
        return self.user_list.check_group(user)
        
    def perspective_logout(self,user):
        return self.user_list.logout(user)    
        
class TestRealm(object):
    implements(portal.IRealm)
    def __init__(self, uList):
        self.user_list = uList
        
    def requestAvatar(self, avatarId, mind, *interfaces):
        if not pb.IPerspective in interfaces:
            raise NotImplementedError, "No supported avatar interface."
        else:
            avatar = UserPerspective(self.user_list)
            return pb.IPerspective, avatar, lambda: None
            
if __name__ == "__main__":
    import sys
    from twisted.internet import reactor
    p = portal.Portal(TestRealm(UserList()))
    p.registerChecker(
        checkers.InMemoryUsernamePasswordDatabaseDontUse(
        user1='a',user2='b',user3='c',user4='d'))
    reactor.listenTCP(8789, pb.PBServerFactory(p))
    print "Server Started"
    reactor.run( )